#pragma once

#ifdef UNICODE
#define STRLEN(x)   wcslen(x)
#else
#define STRLEN(x)   strlen(x)
#endif
#define FontBigHeight 34
#define FontWide 0 //8
#define FontHeight 24	 //22 // 20
#define TitleFontWide  11 //9
#define TitleFontHeight 34 //26 //22
#define LongTitleFontWide 0 //10
#define LongTitleFontHeight 34 //26 //24

#define MenuButtonFontWide 0 //14
#define MenuButtonFontHeight 34 //32
#define ShortButtonFontWide 0 //7
#define ShortButtonFontHeight 24 //18 //16
#define ButtonFontWide //9
#define ButtonFontHeight 34 //22 //20
#define LongButtonFontWide //10
#define LongButtonFontHeight 34 //26  //

#define TitleonoffFontWide 0//12
#define TitleonoffFontHeight 28 //26
#define onoffFontWide 0 //6
#define onoffFontHeight 16 //14

#define EditFontHeight 36 //14
#define EditFontWidth 12 //14
extern HFONT ghEditFont;
extern HFONT ghKeyFont;
extern HFONT ghHugeFont;

class DrawDC 
{


public:
	DrawDC(HDC dc) 
	{
      
        m_hDC=dc;	
		//Ūre
		//::GetCharWidth32(m_hDC,0,255,)
		//::GetCharABCWidths(m_hDC,0,255,&abc);
		::GetTextMetrics(m_hDC,&tm);
		m_Oldfont=NULL;
	    m_font   =NULL;
		
	}
	~DrawDC()
	{
         if(m_Oldfont)
		 { 
		     ::SelectObject(m_hDC,m_Oldfont);
		     if(m_font) ::DeleteObject(m_font);
		 }
	}
    
	int SetDrawTextColor(COLORREF Color)
	{
		return ::SetTextColor(m_hDC,Color);
	}

	int SetDrawBKColor(COLORREF Color)
	{
		return ::SetBkColor(m_hDC,Color);
	}


    int SetDrawBkMode(int Mode)
	{
		return ::SetBkMode(m_hDC,Mode);  
	}
	HFONT SetFont(HFONT hFont)
	{
		//m_font = hFont;
		m_Oldfont=(HFONT )::SelectObject(m_hDC,hFont);
		::GetTextMetrics(m_hDC,&tm);
		return m_Oldfont;
	}
    int SetDrawFontSize(int Hight,int Width,int Bold,LPCTSTR fontname)
	{
	
		if(m_Oldfont)
		{
		     ::SelectObject(m_hDC,m_Oldfont);
		     if(m_font)::DeleteObject(m_font);
		     m_font = 0;
		}

		m_font = CreateFont(Hight,                //14-r鰪
			                Width,                //13-re
							0,                    //12-r׫
							0,                    //11-u׫
							Bold,            //10-rʲ
 			                FALSE,                // 9-]wr鬰  
							FALSE,                // 8-]wr驳u 
							0,                    // 7-]wRu
							DEFAULT_CHARSET,          // 6-]wr
							OUT_DEFAULT_PRECIS,       // 5-rXѪR
							CLIP_DEFAULT_PRECIS,      // 4-r^ѪR
							CLEARTYPE_QUALITY,//CLEARTYPE_COMPAT_QUALITY /*DRAFT_QUALITY*/ ,      //3-r
							DEFAULT_PITCH|FF_SWISS,   //2r骺~[Ѧ(Sһݦrɥ)
							fontname);                //1-rW
		         

		m_Oldfont=(HFONT )::SelectObject(m_hDC,m_font);

	    ::GetTextMetrics(m_hDC,&tm);
		return 0;
	}

	void SetHelpFont(BOOL bBold=0)
	{
		SetDrawBkMode(TRANSPARENT);
		SetDrawTextColor(RGB(0,0,0));
		SetDrawFontSize(FontHeight,FontWide,bBold?FW_BOLD:FW_NORMAL,__FONT_NORMAL__);
	}
	void SetMsgBoxFont()
	{
		SetDrawBkMode(TRANSPARENT);
		SetDrawTextColor(RGB(0,0,0));
		SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
	}



	void DrawGPSOverIPStringRect(TCHAR *String,LPRECT pRC,UINT uFormat)
	{
		LPRECT Rect ;
		RECT rc = (*pRC);
		Rect = &rc;
		int c_line = 1;  // number of string
		TCHAR *Str;
		Str = String;
		if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == TEXT('\n'))
					c_line++;
				*Str++;
			}
			if(c_line > 1)
			{
				uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}
		}
		
		if(fnSkinDrawString) {
			//fnSkinDrawString(m_hDC ,Rect,String,uFormat);
			::SetTextColor(m_hDC,RGB(255,255,255));
			::DrawText(m_hDC,String,-1,Rect,uFormat);
		}
		else{
			::SetTextColor(m_hDC,RGB(200,200,200));
			Rect->left-=1;
			Rect->top -=1;
			Rect->right-=1;
			Rect->bottom-=1;
			::DrawText(m_hDC,String,-1,Rect,uFormat);

			::SetTextColor(m_hDC,RGB(220,223,223));
			Rect->left+=2;
			Rect->top +=2;
			Rect->right+=2;
			Rect->bottom+=2;
			::DrawText(m_hDC,String,-1,Rect,uFormat);

			::SetTextColor(m_hDC,RGB(0,0,0));
			Rect->left-=1;
			Rect->top -=1;
			Rect->right-=1;
			Rect->bottom-=1;
			::DrawText(m_hDC,String,-1,Rect,uFormat);
		}
	}
	void DrawGPSOverIPStringRectBlack(TCHAR *String,LPRECT pRC,UINT uFormat)
	{
		LPRECT Rect ;
		RECT rc=(*pRC);
		Rect = &rc;
		int c_line = 1;  // number of string
		TCHAR *Str;
		Str = String;
		if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == TEXT('\n'))
					c_line++;
				*Str++;
			}
			if(c_line > 1)
			{
				uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}
		}
		
		if(fnSkinDrawString) {
			::SetTextColor(m_hDC,RGB(0,0,0));
			::DrawText(m_hDC,String,-1,Rect,uFormat);
			//fnSkinDrawString(m_hDC ,Rect,String,uFormat);
		}
		else{
			::SetTextColor(m_hDC,RGB(0,0,0));
			Rect->left-=1;
			Rect->top -=1;
			Rect->right-=1;
			Rect->bottom-=1;
			::DrawText(m_hDC,String,-1,Rect,uFormat);

			::SetTextColor(m_hDC,RGB(220,223,223));
			Rect->left+=2;
			Rect->top +=2;
			Rect->right+=2;
			Rect->bottom+=2;
			::DrawText(m_hDC,String,-1,Rect,uFormat);

			::SetTextColor(m_hDC,RGB(0,0,0));
			Rect->left-=1;
			Rect->top -=1;
			Rect->right-=1;
			Rect->bottom-=1;
			::DrawText(m_hDC,String,-1,Rect,uFormat);
		}

	}
	void DrawMultiLineStringRect(TCHAR *String,LPRECT Rect,UINT uFormat)
	{
		int c_line = 1;  // number of string
		TCHAR *Str, *pStr;
		Str = String; 
		pStr = String;
		::SetTextColor(m_hDC,RGB(0,0,0));
		Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;
		Rect->bottom= Rect->top + (tm.tmHeight + 4 );
	//	if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == TEXT('\n'))
				{
					c_line++;
					*Str = 0;
					
					::DrawText(m_hDC,pStr,-1,Rect,uFormat);
					pStr = Str+1;
					Rect->top += (tm.tmHeight + 4 );
					Rect->bottom= Rect->top + (tm.tmHeight + 4 );
				}
				*Str++;
			}
			::DrawText(m_hDC,pStr,-1,Rect,uFormat);
			/*if(c_line > 1)
			{
				//uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}*/
		}
/*		::SetTextColor(m_hDC,RGB(200,200,200));
		Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;
		::DrawText(m_hDC,String,-1,Rect,uFormat);

		::SetTextColor(m_hDC,RGB(220,223,223));
		Rect->left+=2;
		Rect->top +=2;
		Rect->right+=2;
		Rect->bottom+=2;
		::DrawText(m_hDC,String,-1,Rect,uFormat);

		::SetTextColor(m_hDC,RGB(0,0,0));
		Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;
		::DrawText(m_hDC,String,-1,Rect,uFormat); */

	}
	void Draw3DRect(LPRECT Rect ,int roundwidth, int roundheight,int bFill=1)
	{
		RECT rt={Rect->left+1,Rect->top+1,Rect->right,Rect->bottom};
		DrawFillRoundRect(Rect,RGB(0x6E,0x6E,0x70),10,10);
		DrawFillRoundRect(&rt,RGB(0xA4,0xA5,0xA9),10,10);
		rt.left=Rect->left+1,rt.top=Rect->top+1,rt.right=Rect->right-1,rt.bottom=Rect->bottom-1;
		DrawFillRoundRect(&rt,RGB(255,255,255),10,10);

#if 0
		 HPEN aPen ,oldpen ;
		 HBRUSH aBrush=0, oldbrush=0;
		 aPen = ::CreatePen(PS_SOLID, 1, RGB(96,96,96));
roundwidth+=3;roundheight+=3;	
		 if(bFill){
			 aBrush = ::CreateSolidBrush(RGB(255,255,255)); 
			 oldbrush = (HBRUSH)::SelectObject(m_hDC,aBrush);
		 }
        oldpen = (HPEN)::SelectObject(m_hDC,aPen); 
		Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;

		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);

    	SelectObject(m_hDC,oldpen);
		DeleteObject(aPen);
		if(bFill){
			SelectObject(m_hDC,oldbrush);
			DeleteObject(aBrush);
		}	
/*		aPen = ::CreatePen(PS_SOLID, 1, RGB(255,255,255));
		Rect->left+=2;
		Rect->top +=2;
		Rect->right+=2;
		Rect->bottom+=2;
		oldpen = (HPEN)::SelectObject(m_hDC,aPen);
		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);
		SelectObject(m_hDC,oldpen);
		DeleteObject(aPen);
*/
		//aPen = ::CreatePen(PS_SOLID, 1, RGB(115,116,117));
		aPen = ::CreatePen(PS_SOLID, 1, RGB(200,200,200));
		Rect->left+=1;
		Rect->top +=1;
		//Rect->right-=1;
		//Rect->bottom-=1;
		oldpen = (HPEN)::SelectObject(m_hDC,aPen);
		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);
		SelectObject(m_hDC,oldpen);
		DeleteObject(aPen);
#endif

	}

	void DrawGPSOverIPStringRectDisable(TCHAR *String,LPRECT Rect,UINT uFormat)
	{
        int c_line = 1;  // number of string
		TCHAR *Str;
		Str = String;
		if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == '\n')
					c_line++;
				*Str++;
			}
			if(c_line > 1)
			{
				uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}
		}
		::SetTextColor(m_hDC,RGB(150,150,150));
		/*Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;
		*/::DrawText(m_hDC,String,-1,Rect,uFormat);
/*
		::SetTextColor(m_hDC,RGB(220,223,223));
		Rect->left+=2;
		Rect->top +=2;
		Rect->right+=2;
		Rect->bottom+=2;
		::DrawText(m_hDC,String,-1,Rect,uFormat);

		::SetTextColor(m_hDC,RGB(115,116,117));
		Rect->left-=1;
		Rect->top -=1;
		Rect->right-=1;
		Rect->bottom-=1;
		::DrawText(m_hDC,String,-1,Rect,uFormat);
*/
	}


	void DrawStringRect(TCHAR *String,LPRECT Rect,UINT uFormat)
	{
		int c_line = 1;  // number of string
		TCHAR *Str;
		Str = String;
		if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == '\n')
					c_line++;
				*Str++;
			}
			if(c_line > 1)
			{
				uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}
		}
    	::DrawText(m_hDC,String,-1,Rect,uFormat);
	}

	void DrawStringRectWhite(TCHAR *String,LPRECT Rect,UINT uFormat)
	{
		int c_line = 1;  // number of string
		TCHAR *Str;
		Str = String;
		if((uFormat & DT_VCENTER) == DT_VCENTER)
		{
			while(*Str != 0)
			{
				if(*Str == '\n')
					c_line++;
				*Str++;
			}
			if(c_line > 1)
			{
				uFormat = uFormat & (0xFFFFFFFB);
				Rect->top += ((Rect->bottom - Rect->top)-(tm.tmHeight * c_line))/2;
			}
		}
    	::DrawText(m_hDC,String,-1,Rect,uFormat);
	}

	void DrawRoundRect(LPRECT Rect, UINT bold, COLORREF Color, int roundwidth, int roundheight)
    {
		 HPEN aPen;
		 aPen = ::CreatePen(PS_SOLID, bold, Color);
		 HPEN oldpen = (HPEN)::SelectObject(m_hDC,aPen);
         
		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);

    	 SelectObject(m_hDC,oldpen);
		::DeleteObject(aPen);
    }
 
	//roundwidth: the width of the ellipse used to draw the rounded corners (in logical units).
    //roundheight: the height of the ellipse used to draw the rounded corners 
	void DrawNewRect(LPRECT Rect, bool white, bool inner) {
		int x = Rect->left;
        int y = Rect->top;
		int r = Rect->right - 1;
		int b = Rect->bottom - 1;
        int ra = 7;
		COLORREF col [8]; 
		if (white) {
			col[0] = RGB(100, 100, 100);
			col[1] = RGB(170, 170, 170);
			col[2] = RGB(196, 196, 196);
			col[3] = RGB(208, 208, 208);
			col[4] = RGB(217, 217, 217);
			col[5] = RGB(255, 255, 255); //RGB(238, 238, 238);
			col[6] = RGB(255, 255, 255); //RGB(245, 245, 245);
			col[7] = RGB(255, 255, 255); //RGB(247, 247, 247);
		} else {
			col[0] = RGB(90, 90, 90);
			col[1] = RGB(140, 140, 140);
			col[2] = RGB(155, 155, 155);
			col[3] = RGB(170, 170, 170);
			col[4] = RGB(182, 182, 182);
			col[5] = RGB(190, 190, 190);
			col[6] = RGB(195, 195, 195);
			col[7] = RGB(198, 195, 198);
		}
        for (int z = 0; z < ra; z++)
        {
			HPEN aPen;
			HBRUSH aBrush;
			aPen = ::CreatePen(PS_SOLID, 1, col[z]); // ~Color);
			aBrush = ::CreateSolidBrush(col[z]); 
	       	HPEN oldpen = (HPEN)::SelectObject(m_hDC,aPen);
			HBRUSH oldbrush = (HBRUSH)::SelectObject(m_hDC,aBrush);

			::Ellipse(m_hDC, x + z, y + z, x + z + ra + 2, y + z + ra + 2);
			::Ellipse(m_hDC, r - z - ra, y + z, r - z - ra + ra + 2, y + z + ra + 2);
			::Ellipse(m_hDC, x + z, b - z - ra, x + z + ra + 2, b - z - ra + ra + 2);
			::Ellipse(m_hDC, r - z - ra, b - z - ra, r - z - ra + ra + 2, b - z - ra + ra + 2);
			
			::MoveToEx(m_hDC, x + ra, y + z, (LPPOINT) NULL); //oben
			::LineTo(m_hDC, r - ra + 2, y + z); 
			::MoveToEx(m_hDC, x + z, y + ra, (LPPOINT) NULL); //links
			::LineTo(m_hDC, x + z, b - ra + 2); 
			::MoveToEx(m_hDC, x + ra, b - z + 2, (LPPOINT) NULL);  //unten
			::LineTo(m_hDC, r - ra + 2, b - z + 2); 
			::MoveToEx(m_hDC, r - z + 2, y + ra, (LPPOINT) NULL); //rechts
			::LineTo(m_hDC, r - z + 2, b - ra + 2); 
			
			if (inner) {
				::Rectangle(m_hDC,x + ra, y + ra, r - ra+3 , b - ra +3);
			}

    		SelectObject(m_hDC,oldpen);
			::DeleteObject(aPen);
			SelectObject(m_hDC,oldbrush);
			::DeleteObject(aBrush);
        }

	}


//roundwidth: the width of the ellipse used to draw the rounded corners (in logical units).
    //roundheight: the height of the ellipse used to draw the rounded corners 
	void DrawNewRect2(LPRECT Rect, bool white, bool inner,int fill) {
		int x = Rect->left;
        int y = Rect->top;
		int r = Rect->right - 1;
		int b = Rect->bottom - 1;
        int ra = 7;
		COLORREF col [8]; 
		if (white) {
			col[0] = RGB(255, 255, 255); //RGB(100, 100, 100);
			col[1] = RGB(255, 255, 255); //RGB(170, 170, 170);
			col[2] = RGB(255, 255, 255); //RGB(196, 196, 196);
			col[3] = RGB(255, 255, 255); //RGB(208, 208, 208);
			col[4] = fill; //RGB(255, 255, 255); //RGB(217, 217, 217);
			col[5] = fill; //RGB(255, 255, 255); //RGB(238, 238, 238);
			col[6] = fill;//RGB(255, 255, 255); //RGB(245, 245, 245);
			col[7] = fill;//RGB(255, 255, 255); //RGB(247, 247, 247);
		} else {
			col[0] = RGB(252, 179, 52); //RGB(90, 90, 90);
			col[1] = RGB(212, 139, 52); //RGB(140, 140, 140);
			col[2] = RGB(182, 109, 52); //RGB(155, 155, 155);
			col[3] = RGB(152, 89,  52); //RGB(170, 170, 170);
			col[4] = RGB(182, 182, 182);
			col[5] = RGB(190, 190, 190);
			col[6] = RGB(195, 195, 195);
			col[7] = RGB(198, 195, 198);
		}
		if(fill==0) ra=4;
        for (int z = 0; z < ra; z++)
        {
			HPEN aPen;
			HBRUSH aBrush=NULL ,oldbrush=NULL;
			aPen = ::CreatePen(PS_SOLID, 1, col[z]); // ~Color);
			
	       	HPEN oldpen = (HPEN)::SelectObject(m_hDC,aPen);
			if(fill!=0){
				aBrush = ::CreateSolidBrush(col[z]); 
				oldbrush  = (HBRUSH)::SelectObject(m_hDC,aBrush);
			}else oldbrush = (HBRUSH)SelectObject(m_hDC, GetStockObject(HOLLOW_BRUSH));
			if(1)//fill==0)
				RoundRect(m_hDC, x+z,y+z,r-z,b-z,5+5-z,8+5-z);
			else{
				::Ellipse(m_hDC, x + z, y + z, x + z + ra + 2, y + z + ra + 2);
				::Ellipse(m_hDC, r - z - ra, y + z, r - z - ra + ra + 2, y + z + ra + 2);
				::Ellipse(m_hDC, x + z, b - z - ra, x + z + ra + 2, b - z - ra + ra + 2);
				::Ellipse(m_hDC, r - z - ra, b - z - ra, r - z - ra + ra + 2, b - z - ra + ra + 2);
				
				::MoveToEx(m_hDC, x + ra - 1,     y + z, (LPPOINT) NULL); //oben
				::LineTo  (m_hDC, r - ra + 2 + 1, y + z); 

				::MoveToEx(m_hDC, x + z, y + ra -1, (LPPOINT) NULL); //links
				::LineTo  (m_hDC, x + z, b - ra + 2 +1); 
				::MoveToEx(m_hDC, x + ra -1,     b - z + 2, (LPPOINT) NULL);  //unten
				::LineTo  (m_hDC, r - ra + 2 + 1, b - z + 2); 
				::MoveToEx(m_hDC, r - z + 2, y + ra -1, (LPPOINT) NULL); //rechts
				::LineTo  (m_hDC, r - z + 2, b - ra + 2 +1); 
			
				if (inner) {
					::Rectangle(m_hDC,x + ra, y + ra, r - ra+3 , b - ra +3);
				}
			}
    		SelectObject(m_hDC,oldpen);
			::DeleteObject(aPen);
			 
			if( oldbrush ) SelectObject(m_hDC,oldbrush);
			if(aBrush )   ::DeleteObject(aBrush);
        }

	}


	void DrawFillRoundRect(LPRECT Rect, COLORREF Color, int roundwidth, int roundheight)
    {
		 HPEN aPen;
		 HBRUSH aBrush;
		 aPen = ::CreatePen(PS_SOLID, 1, Color); // ~Color);
		 aBrush = ::CreateSolidBrush(Color); 
       
		 HPEN oldpen = (HPEN)::SelectObject(m_hDC,aPen);
         HBRUSH oldbrush = (HBRUSH)::SelectObject(m_hDC,aBrush);
         
		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);

    	SelectObject(m_hDC,oldpen);
		::DeleteObject(aPen);
        SelectObject(m_hDC,oldbrush);
		::DeleteObject(aBrush);
    }
	void DrawFillRoundRect(LPRECT Rect, COLORREF Color,COLORREF fillColor ,int border_w,int roundwidth, int roundheight)
    {
		 HPEN aPen;
		 HBRUSH aBrush;
		 aPen = ::CreatePen(PS_SOLID,border_w, Color); // ~Color);
		 aBrush = ::CreateSolidBrush(fillColor); 

		 HPEN oldpen = (HPEN)::SelectObject(m_hDC,aPen);
         HBRUSH oldbrush = (HBRUSH)::SelectObject(m_hDC,aBrush);
         
		::RoundRect(m_hDC, Rect->left, Rect->top, 
			         Rect->right, Rect->bottom, 
					 roundwidth, roundheight);

    	SelectObject(m_hDC,oldpen);
		::DeleteObject(aPen);
        SelectObject(m_hDC,oldbrush);
		::DeleteObject(aBrush);
    }
	void DrawStringAt(TCHAR *String,int x,int y);

private:
	ABC abc;
	TEXTMETRIC tm;
	HDC   m_hDC;

	HFONT m_font;
	HFONT m_Oldfont;



 	

 //   void DispStringAt(LPCTSTR String,LPRECT lpRect,UINT uFormat) 
	//{
	//	HFONT   m_font;   
 //   
	//	m_hFont = CreateFont(m_iFontSize,0,0,0,iFontBold,iFontItalic,iFontUnderline,iFontStrikeout,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,DEFAULT_PITCH,(LPCTSTR)(m_iFontName) );
	//
	//	//TEXTMETRICW *TextMetrcw;
 //       //LPABC

	//	//GetTextMetrics(TextMetrcw);
	//	//::GetCharABCWidths(m_hDC,
	//	/*SetTextColor(0xFFFFFF);*/
 //       DrawText(String,STRLEN(String),lpRect,uFormat);
	//}


	

};
HFONT create_main_font();
HFONT create_main_font_41(int sz=28);
void ClearObjects();
char *Base64Decode(char * str);